/*
          
JJMASeries.mqh 
PriceSeries.mqh 
  (): MetaTrader\experts\include\
JJMA.mq4
Heiken Ashi#.mq4
  (): MetaTrader\indicators\
*/
//+------------------------------------------------------------------+ 
//|                                                     JJMA_htf.mq4 |
//|                             Copyright  2005, GS  Convrsion only |
//|                    http://www.gustis.narod.ru;     gsb51@mail.ru |
//+------------------------------------------------------------------+ 
#property copyright "  Copyright  2005, GS  Convrsion only"
#property link      " http://www.gustis.narod.ru;  gsb51@mail.ru"
//----     
#property indicator_chart_window
//----   
#property indicator_buffers  1
//----  
#property indicator_color1 Red
//----   
#property indicator_width1 3
//----   
#property indicator_style1 0
//----    --------------------------------------------------------------------------------------------------+
extern int Length = 5;   //   
extern int Phase  = 100; //  ,    -100 ... +100,     ; 
extern int Shift  = 0;   // c     
extern int TFrame_Period=240; //    
extern int Input_Price_Customs = 0;// ,      
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
datetime TFrame_Times[]; 
//----  
double Ind_Buffer[];
//----
int NTF,time1;
//+------------------------------------------------------------------+ 
//| JJMA_htf initialization function                                 | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---------  ---------------------------------------------- 

   //----           
   SetIndexStyle(0,DRAW_SECTION);
   //----     
   IndicatorDigits(Digits);
   SetIndexShift(0, Shift); 
   SetIndexLabel(0,"JJMA_htf");
   SetIndexBuffer(0,Ind_Buffer); 
   SetIndexEmptyValue(0,0.0); 
   NTF=TFrame_Period/Period();  
//-----------  ------------------------------------------------   
   if (TFrame_Period !=1 && TFrame_Period !=5 && TFrame_Period !=15 && TFrame_Period !=30 && TFrame_Period !=60 && TFrame_Period !=240 && TFrame_Period !=1440 && TFrame_Period != 10080)
      { 
       Alert("Chart ", Symbol(), " TimeFrame_period    : 1, 5, 15, 30, 60, 240, 1440, 7200, 10080.\n" +
                                 "     ");
       TFrame_Period=Period();
      }

   if (Period()>= TFrame_Period) 
      {
       TFrame_Period = Period();
       Alert(" TimeFrame_period     !      ");
      }
     
//-------------------------------------------------------------------- 
   //  Time[]       
   ArrayCopySeries(TFrame_Times,MODE_TIME,Symbol(),TFrame_Period); 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| JJMA_htf iteration function                                      | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int MaxBar,bar,MaxBarTF,TFbar,start_bar;
   //----
   MaxBar=Bars-1; 
   //----
   MaxBarTF=MathFloor(MaxBar/NTF);
   //----    
   if (time1!=0)
       {
        TFbar=iBarShift(NULL,TFrame_Period,time1,true);
        if (TFbar<0)
          {
           TFbar=MaxBarTF;
           Print("     .      !"); 
           Print("      "); 
          }
       }
   else TFbar=MaxBarTF;
   //----  
   if (TFbar>=MaxBarTF)
    {
     start_bar=iBarShift(NULL,0,TFrame_Times[TFbar],false);
     for(bar=MaxBar;bar>start_bar;bar--)Ind_Buffer[bar]=0;  
     TFbar=MaxBarTF;
    }
   //----      
   time1=TFrame_Times[1]; 
   //----       
   start_bar=iBarShift(NULL,0,TFrame_Times[TFbar],false);
   for(bar=start_bar;bar>=0;bar--)Ind_Buffer[bar]=0; 
   
   //----+     
   while(TFbar>=-1)  
      {  
        bar=iBarShift(NULL,0,TFrame_Times[TFbar],true)+1; 
        Ind_Buffer[bar]=iCustom(NULL,TFrame_Period,"JJMA",Length,Phase,0,Input_Price_Customs,0,TFbar+1);
        TFbar--;
      }      
    //----    
    return(0);
  }
//----+ +-------------------------------------------------------+